<!DOCTYPE html>

<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>
    <div id="app">
        <form>
            <input type="text" id="myInput" ref="myInput" />
            <button type="button" id="myButton" v-on:click="addOrUpdate">{{myButton}}</button>
        </form>
        <ul>
            <li v-for="(data,i) in users" :key="data.name">
                {{ data.name }}
                <button type="button" id="myEdit" v-on:click="myEdit(i)">{{data.btn}}</button>||
                <button type="button" id="myDelete" v-on:click="myDelete(i)">delete</button>
            </li>
        </ul>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script>
        var vm = new Vue({
            el: '#app',
            data: {
                users: [
                    {
                        'name': 'Muhammad Iqbal Mubarok',
                        'btn': 'edit'
                    },
                    {
                        'name': 'Ruby Purwanti',
                        'btn': 'edit'
                    },
                    {
                        'name': 'Faqih Muhammad',
                        'btn': 'edit'
                    }
                ],
                myButton: "add",
                myIndex: "0"
            },
            methods: {
                addOrUpdate: function (event) {
                    if (this.myButton === "add") {
                        this.users.push({
                            'name': this.$refs.myInput.value,
                            'btn': 'edit'
                        });
                        this.$refs["myInput"].value = "";
                    } else if (this.myButton === "update") {
                        // alert(this.myIndex)
                        // this.users[this.myIndex] = { 'name': this.$refs.myInput.value }
                        // find the block's index in the array
                        // const index = state.contentBlocks.findIndex(block => block.id === contentBlock.id)

                        // // using Vue.set
                        Vue.set(this.users, this.myIndex, {
                            'name': this.$refs.myInput.value,
                            'btn': 'edit'
                        })
                        this.myButton = "edit"
                        this.$refs["myInput"].value = ""

                        // // using Array.splice
                        // this.users.splice(this.myIndex, 1, { 'name': this.$refs.myInput.value })
                    }
                },
                myEdit: function (i) {
                    if (this.users[i].btn === "edit") {
                        this.myIndex = i
                        this.myButton = "update"
                        this.$refs["myInput"].value = this.users[i].name
                        Vue.set(this.users, this.myIndex, {
                            'name': this.$refs.myInput.value,
                            'btn': 'cancel'
                        })
                    } else if (this.users[i].btn === "cancel") {
                        Vue.set(this.users, this.myIndex, {
                            'name': this.$refs.myInput.value,
                            'btn': 'edit'
                        })
                        this.$refs["myInput"].value = ""
                    }
                },
                myDelete: function (i) {
                    if (confirm("Yakin kah ?")) {
                        //Vue.delete
                        Vue.delete(this.users, i);

                        //splice
                        // this.users.splice(i, 1);
                    }

                }
            }
        })
    </script>
</body>

</html>